;Copyright 2012 Daniel Green, v1.00.5b modified 5/24/12 10:48am

;Famulus is free for both business and personal use. It can be freely modified and redistributed providing that, 1. all notices remain intact, 2. you acknowledge where it originally came from, 3. it is only used for legal and ethical purposes, 4. no profit is derived from its distribution.

#noenv
#singleinstance, force
#usehook
setbatchlines, -1
setworkingdir, %a_scriptdir%
setformat, float, 0

menu, tray, nostandard
menu, tray, tip, Famulus
menu, tray, add, Commands, edit_commands
menu, tray, add, Settings, settings
menu, tray, add, About, about
menu, tray, add
menu, tray, add, Exit, exit
menu, tray, default, commands

gosub, get_settings
start_key := key
file := "commands.dat"
gosub, check_startup
gosub, check_sounds


gui, -caption +toolwindow +alwaysontop
gui, color, %color%
gui, add, combobox, r5 x4 y4 w180 h20 vcode gstart_timeout, |
gui, add, button, default hidden x188 y4 w26 h20 gok, OK


hotkey, %key%, activation_key
return

activation_key:
 {
   restart := "1"
   keywait, %a_thishotkey%, t%hold%

   if (errorlevel = "1")
    {
      gosub, prompt
    }
   else
    {
      sendinput, {%a_thishotkey%}
    }
 }
keywait, %a_thishotkey%

start_timeout:
 {
   if (restart = "1")
    {
      settimer, timeout, -%timeout%
    }
 }
return

prompt:
 {
   sysget, var_, monitorworkarea
   x := (var_right-191)
   y := (var_bottom-32)

   increment := 0
   gui, +lastfound
   winset, transparent, %increment%
   gui, color, %color%
   if (lower_right = "1")
    {
      gui, show, x%x% y%y% w188 h29
    }
   else
    {
      gui, show, center w188 h29
    }
    
   if (sounds = "1")
    {
      soundplay, sounds\fade_in.wav
    }
   while, increment < 256
    {
      winset, transparent, %increment%
      increment+=15
      sleep, 1
    }
 }
return

guiescape:
timeout:
 {
   increment := 256
   gui, +lastfound
   while, increment > 0
    {
      winset, transparent, %increment%
      increment-=15
      sleep, 1
    }
   gosub, blank_field
   gui, cancel
   restart := "0"
   gosub, emptymem
 }
return

ok:
 {

   increment := 256
   if (sounds = "1")
    {
      soundplay, sounds\fade_out.wav
    }
   while, increment > 0
    {
      winset, transparent, %increment%
      increment-=15
      sleep, 1
    }
   gui, submit
   gosub, code_list
   restart := "0"
   goto, check
 }
return

check:
 {
   stringleft, first, code, 1
   if (first = "@")
    {
      stringtrimleft, code, code, 1
      run, %code%, , useerrorlevel

      if (errorlevel = "error") or (code = "")
       {
         error("File not recognized by system. Please try again.", sounds, 0)
       }
      gosub, blank_field
      gosub, emptymem
      return
    }

   match := "0"
   getcommands(file)
   loop, %commands0%
    {
      loop, 4
       {
         substring%a_index% := ""
       }

      stringsplit, substring, commands%a_index%, |

      if ("" . code = substring2) && (substring2 != "")
       {
         match := "1"
         run, %substring3%, %substring4%, %substring5% useerrorlevel
		 Stats(substring2) ; stats
         if (errorlevel = "error")
          {
            error("Failure to launch file. Please try again.", sounds, 0)
          }
       }
    }
 
   if (match = "0")
    {
      error("Code does not match any known command. Please try again.", sounds, 0)
    }
   gosub, blank_field
   gosub, emptymem
 }
return

Stats(program,readonly=0)                              ; stats
	{                                                  ; stats
	 file:=A_ScriptDir "\stats.ini"                    ; stats
	 IniRead, OutputVar, %File%, stats, %program%, 0   ; stats
	 if (OutputVar =  "ERROR") or (OutputVar = "")     ; stats
	 	OutputVar:=0                                   ; stats
	 if ReadOnly                                       ; stats
	 	Return OutputVar                               ; stats
	 OutputVar++                                       ; stats
	 IniWrite, %OutputVar%, %File%, stats, %program%   ; stats
	}

error(text, sounds, rel)
 {
   gui, 2:+alwaysontop
   gui, 2:add, picture, icon2 x10 y10 w32 h32, user32.dll
   if (sounds = "1")
    {
      soundplay, sounds\error.wav
    }
   if (rel = "1")
    {
      gui, 2:add, text, x56 y10 w200 h105, %text%
      gui, 2:add, button, default x87 y119 w92 h20 g2guiclose, OK
      gui, 2:show, center w266 h143, ERROR!
    }
   else
    {
      gui, 2:add, text, x56 y10 w200 h40, %text%
      gui, 2:add, button, default x87 y54 w92 h20 g2guiclose, OK
      gui, 2:show, center w266 h78, ERROR!
    }
   return
 }

edit_commands:
 {
   if (commands_gui != "1")
    {
      gui, 3:default
      lv_headers := "Activation Code|File Path - Parameters|Working Directory|Option|Used"
      gui, 3:add, listview, grid nosorthdr sort -lv0x10 -multi altsubmit r20 w700 h305 x10 y10 vlist gget_row, %lv_headers%
      gui, 3:add, groupbox, x10 y320 w700 h80
      gui, 3:add, text, x20 y340 w80 h20, Activation Code:
      gui, 3:add, edit, x103 y340 w137 h20 vactivation_code,
      gui, 3:add, text, x250 y340 w50 h20, File Path:
      gui, 3:add, edit, x300 y340 w326 h20 vfile_path,
      gui, 3:add, button, x628 y340 w30 h20 gget_path, File
      gui, 3:add, button, x658 y340 w30 h20 gget_path_dir, Dir.
      gui, 3:add, button, x688 y340 w12 h20 gopen_with, *
      gui, 3:add, text, x20 y370 w40 h20, Option:
      gui, 3:add, dropdownlist, r4 x60 y370 w136 h20 voption, |max|min|hid
      gui, 3:add, text, x206 y370 w90 h20, Working Directory:
      gui, 3:add, edit, x300 y370 w368 h20 vwork_dir,
      gui, 3:add, button, x670 y370 w30 h20 gget_dir, Dir.
      gui, 3:add, button, x10 y410 w60 h20 gclear, Clear
      gui, 3:add, button, x70 y410 w60 h20 gconvert_path, Convert
      gui, 3:add, button, x530 y410 w60 h20 gsave, Save
      gui, 3:add, button, x590 y410 w60 h20 gdelete, Delete
      gui, 3:add, button, default x650 y410 w60 h20 g3guiclose, Done
      gui, 3:show, w720 h435, Commands
      commands_gui := "1"
    }
   goto, list
 }
return

settings:
 {
   if (settings_gui != "1")
    {
      gui, 4:add, groupbox, x7 y10 w280 h50, Activation
      gui, 4:add, text, x17 y30 w30 h20, Key:
      gui, 4:add, hotkey, x47 y30 w70 h20 vkey
      gui, 4:add, text, x127 y30 w30 h20, Hold:
      gui, 4:add, edit, x157 y30 w30 h20 vhold
      gui, 4:add, text, x197 y30 w50 h20, TimeOut:
      gui, 4:add, edit, number x247 y30 w30 h20 vtimeout
      gui, 4:add, groupbox, x7 y70 w280 h80, Interface
      gui, 4:add, text, x16 y91 w30 h20, Color:
      gui, 4:add, edit, limit x48 y91 w50 h20 vcolor gshow_color
      gui, 4:add, progress, x100 y91 w20 h20 disabled vdisplay_box
      gui, 4:add, checkbox, x17 y120 w60 h20 vsounds, Sounds
      gui, 4:add, groupbox, x132 y90 w145 h50, Position
      gui, 4:add, radio, x140 y110 w50 h20 vcenter, Center
      gui, 4:add, radio, x197 y110 w75 h20 vlower_right, Lower Right
      gui, 4:add, groupbox, x7 y160 w280 h50, Misc.
      gui, 4:add, checkbox, x17 y180 w60 h20 vstartup, Startup
      gui, 4:add, button, x7 y220 w60 h20 gsettings_default, Default
      gui, 4:add, button, default x167 y220 w60 h20 gsettings_save, Save
      gui, 4:add, button, x227 y220 w60 h20 g4guiclose, Cancel
      settings_controls(key, hold, (timeout/1000), color, center, lower_right, sounds, startup)
      gui, 4:show, center w295 h245, Settings
      settings_gui := "1"
    }
 }
return

show_color:
 {
   gui, 4:submit, nohide
   guicontrol, 4:+background%color%, display_box
 }
return

about:
 {
   if (about_gui != "1")
    {
      gosub, get_about
      gui, 5:add, button, x10 y375 w60 h20 ghome_site, Home
      gui, 5:add, button, x70 y375 w60 h20 ghelp_site, Help
      gui, 5:add, button, default x450 y375 w60 h20 g5guiclose, OK
      gui, 5:add, edit, +readonly vscroll x10 y10 w500 h360, %about%
      gui, 5:show, center w520 h400, About Famulus
      about_gui = "1"
    }
 }
return

home_site:
 {
   run, http://crzyinc.weebly.com/famulus.html
 }
return

help_site:
 {
   run, http://crzyinc.weebly.com/famulus-help.html
 }
return

list:
 {
   getcommands(file)
   loop, %commands0%
    {
      if (commands%a_index% = "")
       {
         continue
       }
      loop, 4
       {
         substring%a_index% := ""
       }
      stringsplit, substring, commands%a_index%, |
      lv_add("", substring2, substring3, substring4, substring5,Stats(substring2,1)) ; stats
      
      loop, 3
       {
         lv_modifycol(a_index, "autohdr")
       }
      lv_modifycol(4, 50)
    }
 }
return

get_row:
 {
   if (a_guievent = "normal") && (a_eventinfo != "0") && (a_eventinfo != rownumber)
    {
      rownumber := a_eventinfo
   
      loop, 4
       {
         lv_gettext(text%a_index%, a_eventinfo, a_index)
       }
    
      row_string := "|" . text1 . "|" . text2 . "|" . text3 . "|" . text4 . "|"
      change_controls(text1, text2, text3, text4, 0)
    }
 }
return

get_path:
 {
   fileselectfile, file_path, 3, , Please select file...
   guicontrol, 3:, file_path, %file_path%
 }
return

get_path_dir:
 {
   fileselectfolder, file_path, , 1, Please select directory...
   guicontrol, 3:, file_path, %file_path%
 }
return

open_with:
 {
   fileselectfile, exe_path, 3, , Please select application..., (*.exe)
   if (errorlevel = "0")
    {
      fileselectfile, file_path, 3, , Please select file...
    }
   if (errorlevel = "0")
    {
      guicontrol, 3:, file_path, "%exe_path%" "%file_path%"
    }
 }
return

get_dir:
 {
   fileselectfolder, work_dir, , 1, Please select directory...
   guicontrol, 3:, work_dir, %work_dir%
 }
return

clear:
 {
   row_string := ""
   change_controls("", "", "", "", 1)
 }
return

convert_path:
 {
   gui, 3:submit, nohide
   if (file_path != "")
    {
      stringleft, file_path_temp, file_path, 2
      stringleft, a_scriptdir_temp, a_scriptdir, 2

      if (file_path_temp = a_scriptdir_temp)
       {
         file_path := getrelativepath(a_scriptdir, file_path)
       }
      else
       {
         error("Unable to convert path:`n   1. Drive may be other than that from which Famulus is currently running.`n   2. Path may be a web address.`n   3. Path may already be relative, or missing a drive letter.`n   4. Path may a dual 'open with' path.", sounds, 1)
       }
      change_controls(activation_code, file_path, work_dir, option, "0")
    }
 }
return

save:
 {
   gui, 3:submit, nohide
   new_command := "|" . activation_code . "|" . file_path . "|" . work_dir . "|" . option . "|"
   if (activation_code != "") && (file_path != "") && (row_string != new_command)
    {
      gosub, delete
      fileappend, `r`n%new_command%, %file%
      getcommands(file)
      lv_delete()
      gosub, list
      new_command := ""
      change_controls("", "", "", "", 1)
    }
 }
return

delete:
 {
   removeline(row_string, file)
   getcommands(file)
   lv_delete()
   gosub, list
   row_string := ""
   rownumber := ""
   change_controls("", "", "", "", 1)
 }
return

3guidropfiles:
 {
   if (a_guicontrol = "file_path")
    {
      stringsplit, drop_file, a_guievent, `n
      guicontrol, 3:, file_path, %drop_file1%
    }
   else if (a_guicontrol = "work_dir")
    {
      stringsplit, drop_file, a_guievent, `n
      stringright, check_ext, drop_file1, 6
      ifinstring, check_ext, .
       {
         error("This appears to be a file. Only a folder can be set as working directory.", sounds, 0)
         return
       }
      guicontrol, 3:, work_dir, %drop_file1%
    }
 }
return

get_settings:
 {
   iniread, key, settings.ini, settings, key, numpadmult
   if (key = "")
    {
      key := "numpadmult"
    }
   iniread, hold, settings.ini, settings, hold, .2
   if (hold = "")
    {
      hold := "200"
    }
   iniread, timeout, settings.ini, settings, timeout, 10000
   if (timeout = "")
    {
      timeout := "10000"
    }
   iniread, color, settings.ini, settings, color, 000000
   if (color = "")
    {
      color := "000000"
    }
   iniread, lower_right, settings.ini, settings, lower_right, 1
   center := "0"
   if (lower_right = "")
    {
      lower_right := "1"
      center := "0"
    }
   if (lower_right != "1") && (lower_right != "")
    {
      lower_right := "0"
      center := "1"
    }
   iniread, sounds, settings.ini, settings, sounds, 1
   if (sounds = "")
    {
      sounds := "1"
    }
   iniread, startup, settings.ini, settings, startup, 0
   if (sounds = "")
    {
      sounds := "0"
    }
 }
return

settings_default:
 {
   settings_controls("numpadmult", ".2", "10", "000000", "0", "1", "1", "0")
 }
return

settings_save:
 {
   gui, 4:submit
   timeout := (timeout*1000)
   stringlower, key, key
   iniwrite, %key%, settings.ini, settings, key
   iniwrite, %hold%, settings.ini, settings, hold
   iniwrite, %timeout%, settings.ini, settings, timeout
   iniwrite, %color%, settings.ini, settings, color
   iniwrite, %lower_right%, settings.ini, settings, lower_right
   iniwrite, %sounds%, settings.ini, settings, sounds
   iniwrite, %startup%, settings.ini, settings, startup
   gosub, get_settings
   gui, 4:destroy
   if (start_key != key)
    {
      reload
    }
   gosub, check_startup
   gosub, check_sounds
   settings_gui := "0"
 }
return

check_startup:
 {
   if (startup = "1")
    {
      filecreateshortcut, %a_scriptfullpath%, %a_startup%\Famulus.lnk
    }
   else if (startup = "0") && fileexist(a_startup . "\Famulus.lnk")
    {
      filedelete, %a_startup%\Famulus.lnk
    }
 }
return

check_sounds:
 {
   if (sounds = "1") && !fileexist("sounds")
    {
      filecreatedir, sounds
      fileinstall, sounds\error.wav, sounds\error.wav, 0
      fileinstall, sounds\fade_in.wav, sounds\fade_in.wav, 0
      fileinstall, sounds\fade_out.wav, sounds\fade_out.wav, 0
    }
 }
return

settings_controls(key, hold, timeout, color, center, lower_right, sounds, startup)
 {
   guicontrol, 4:, key, %key%
   guicontrol, 4:, hold, %hold%
   guicontrol, 4:, timeout, %timeout%
   guicontrol, 4:, color, %color%
   guicontrol, 4:, center, %center%
   guicontrol, 4:, lower_right, %lower_right%
   guicontrol, 4:, sounds, %sounds%
   guicontrol, 4:, startup, %startup%
 }
return

code_list:
 {
   if (code != code1) && (code != code2) && (code != code3) && (code != code4) && (code != code5) && (code != "")
    {
      count++
      code5 := code4
      code4 := code3
      code3 := code2
      code2 := code1
      code1 := code

      if (count = 1)
       {
         guicontrol, , code, |%code1%
         last_content := "|" . code1
       }
      else if (count = 2)
       {
         guicontrol, , code, |%code1%|%code2%
         last_content := "|" . code1 . "|" . code2
       }
      else if (count = 3)
       {
         guicontrol, , code, |%code1%|%code2%|%code3%
         last_content := "|" . code1 . "|" . code2 . "|" code3
       }
      else if (count = 4)
       {
         guicontrol, , code, |%code1%|%code2%|%code3%|%code4%
         last_content := "|" . code1 . "|" . code2 . "|" code3 . "|" . code4
       }
      else
       {
         guicontrol, , code, |%code1%|%code2%|%code3%|%code4%|%code5%
         last_content := "|" . code1 . "|" . code2 . "|" code3 . "|" . code4 . "|" . code5
       }
    }
 }
return

blank_field:
 {
   if (last_content = "")
    {
      guicontrol, , code, ||
    }
   else
    {
      guicontrol, , code, %last_content%
    }
 }
return

2guiclose:
 {
   gui, 2:destroy
   gosub, emptymem
 }
return

3guiclose:
 {
   gui, 3:destroy
   commands_gui := "0"
   gosub, emptymem
 }
return

4guiclose:
 {
   gui, 4:destroy
   settings_gui := "0"
   gosub, get_settings
   gosub, emptymem
 }
return

5guiclose:
 {
   gui, 5:destroy
   about_gui := "0"
   about := ""
   gosub, emptymem
 }
return

change_controls(activation_code, file_path, work_dir, option, submit)
 {
   guicontrol, 3:, activation_code, %activation_code%
   guicontrol, 3:, file_path, %file_path%
   guicontrol, 3:, work_dir, %work_dir%

   if (option = "")
    {
      guicontrol, 3:, option, ||min|max|hid
    }
   else if (option = "min")
    {
      guicontrol, 3:, option, ||min||max|hid
    }
   else if (option = "max")
    {
      guicontrol, 3:, option, ||min|max||hid
    }
   else if (option = "hid")
    {
      guicontrol, 3:, option, ||min|max|hid||
    }
   if (submit = "1")
    {
      gui, 3:submit, nohide
    }
   return
 }

getrelativepath(from, to)
 {
   VarSetCapacity(pszPath,MAX_PATH:=260)
   if DllCall("Shlwapi\PathRelativePathTo"
      , "PTR", &pszPath
      , "STR", from
      , "UInt", InStr(from,"D")?FILE_ATTRIBUTE_DIRECTORY:=16:0
      , "Str", To
      , "UInt", InStr(to,"D")?FILE_ATTRIBUTE_DIRECTORY:0)
    {
      return StrGet(&pszPath)
    }
   else 
    {
      return -1
    }
 }

getcommands(file)
 {
   global
   fileread, commands, %file%
   stringreplace, commands, commands, `r`n, , 1
   stringsplit, commands, commands, 
   return
 }

removeline(line, file)
 {
   fileread, content, %file%
   stringreplace, content, content, %line%, , 1
   stringreplace, content, content, `r`n`r`n,`r`n, 1
   filedelete, %file%
   fileappend, %content%, %file%
   return
 }

get_about:
 {
about := 
(
"Famulus v1.00.5b

Copyright 2012 Daniel Green

Famulus (Latin for servant) is a simple text based file and application launcher. Most file launchers employ a graphical interface, but a few, like Famulus and the Windows Run utility, use typed commands.

Famulus works by holding down a designated key (default is the numpad * key) for a fraction of a second, which will cause a prompt to be displayed. In this prompt you can type predefined commands associated with files or folders on your computer, or by prepending the @ symbol you can type web addresses, file paths or system commands and have them run directly.

Famulus is free for both business and personal use. It can be freely modified and redistributed providing that, 1. all notices remain intact, 2. you acknowledge where it originally came from, 3. it is only used for legal and ethical purposes, 4. no profit is derived from its distribution.

Features:
   Use custom alpha-numeric commands to run files, folders and websites.
   Prepend the @ symbol to directly run web addresses, file paths or system commands.
   The previous 5 commands are stored for easy reference.
   Portable, can run from removable media and makes no changes to the host system.
   Open source, written in AutoHotkey (http://www.autohotkey.com).

Requirements:
   Windows 2000 - Win7

History:
   v1.00.5b
      Fixed two significant bugs in how the activation key works.
   v1.00.4b
      Removed default commands.dat and settings.ini files to prevent accidental overwrite.
      Miner gui adjustments.
      Miner code revisions.
   v1.00.3b
      Minor gui bug fix.
      Reduced application size.
   v1.00.2b
      Sounds folder now only restored, not deleted.
      Minor gui bug fix.
      Help updated.
   v1.00.1b
      Sounds folder now automatically deleted or restored when sounds setting changed.
      Dramatically reduced size of error.wav and Famulus.exe.
      Removed some files from source folder.
      Inclusion of Windows Run command list.
   v1.00.0b
      Initial beta release.

Known bugs:
   The Commands gui has a couple of quirks.
   The prompt timeout sometimes fails.
   If using modifiers with the activation key the hold time is ignored, causing it to work as any normal hotkey.

Thanks to:
   Mr. Jody Holmes of http://skwire.dcmembers.com for helping with a sound issue.
   guinness of http://softwarespot.wordpress.com/ for alpha testing and suggesting several main features and improvements.
   Several members of the AutoHotkey community (http://www.autohotkey.com/forum/forum-1.html) for helping to solve more issues than I can think of at the moment.

Fade_in.wav:
   Robot Blip 2
   Downloaded from http://soundbible.com
   Recorded by Marianne Gagnon
   Released under a Attribution 3.0 license
Fade_out.wav:
   Robot Blip
   Downloaded from http://soundbible.com
   Recorded by Marianne Gagnon
   Released under a Attribution 3.0 license
Error.wav:
   Computer Error Alert
   Downloaded from http://soundbible.com
   Recorded by Mike Koenig
   Released under a Attribution 3.0 license

The program icon is based on the Albook extended icon set by StopDreaming (http://stopdreaming.deviantart.com/).
Original Albook project by Laurent Baumann (http://lbaumann.com/).
Albook icons, and all derivative works, are released under the Creative Commons License 2.5 (http://creativecommons.org/licenses/by/2.5/)."
)
 }
return

exit:
 {
   exitapp
 }
return

emptymem:
 {
   dllcall("psapi.dll\EmptyWorkingSet", "UInt", -1)
 }
return